#!/bin/bash
#online or offline
#set -x
#set -e
style=$1 
enabled=$2
repo_address=$3

clean()
{
	/usr/sbin/yum-complete-transaction --cleanup-only
	sleep 1
	yum clean dbcache rpmdb
}

update_system()
{
        yum repolist | grep softcenter-repo
        softcenter_repo=$?

        if [ ${softcenter_repo} == "0" ];then
                yum-config-manager --disable softcenter-repo
        fi

	yum clean dbcache rpmdb
	sleep 1
	yum update -y
        #pkcon update -y
	if [ $? == "0" ];then
                if [ ${softcenter_repo} == "0" ];then
                        yum-config-manager --enable softcenter-repo
                fi
		exit 0
	else
                if [ ${softcenter_repo} == "0" ];then
                        yum-config-manager --enable softcenter-repo
                fi
		exit -1
	fi
}

write_offline_repo()
{
echo "[neokylin-offline]
name=NeoKylin-offline - \$basearch
baseurl=$1
enabled=$2
gpgcheck=0
skip_if_unavailable = 1
keepcache = 0" > /etc/yum.repos.d/offline.repo
if [ $SYSTEM = "aarch64" ];then
    echo "gpgkey=file:///etc/pki/rpm-gpg/RPM-GPG-KEY-neokylin-release" >> /etc/yum.repos.d/offline.repo
elif [ $SYSTEM = "mips64el" ];then
    echo "gpgkey=file:///etc/pki/rpm-gpg/RPM-GPG-KEY-neokylin-release" >> /etc/yum.repos.d/offline.repo
else
    echo "gpgkey=file:///etc/pki/rpm-gpg/RPM-GPG-KEY-neokylin-\$basearch" >> /etc/yum.repos.d/offline.repo
fi
}

write_online_repo()
{
echo "[Neokylin-online]
name=NeoKylin-online - \$basearch
baseurl=$1
enabled=$2
gpgcheck=0
skip_if_unavailable = 1" > /etc/yum.repos.d/online.repo
if [ $SYSTEM = "aarch64" ];then
    echo "gpgkey=file:///etc/pki/rpm-gpg/RPM-GPG-KEY-neokylin-release" >> /etc/yum.repos.d/online.repo
elif [ $SYSTEM = "mips64el" ];then
    echo "gpgkey=file:///etc/pki/rpm-gpg/RPM-GPG-KEY-neokylin-release" >> /etc/yum.repos.d/online.repo
else
    echo "gpgkey=file:///etc/pki/rpm-gpg/RPM-GPG-KEY-neokylin-\$basearch" >> /etc/yum.repos.d/online.repo
fi

}

write_default_repo()
{
echo "[neokylin]
name=NeoKylin $3
baseurl=$1
enabled=$2
gpgcheck=0
skip_if_unavailable = 1
keepcache=0" > /etc/yum.repos.d/neokylin.repo
if [ $SYSTEM = "aarch64" ];then
echo "gpgkey=file:///etc/pki/rpm-gpg/RPM-GPG-KEY-neokylin-release

[Neokylin-extras]
name=NeoKylin 7 extras
baseurl=http://download.cs2c.com.cn/neokylin/desktop/everything/7.0/\$basearch/os/
gpgcheck=0
gpgkey=file:///etc/pki/rpm-gpg/RPM-GPG-KEY-neokylin-release
enabled=0" >> /etc/yum.repos.d/neokylin.repo
elif [ $SYSTEM = "mips64el" ];then
echo "gpgkey=file:///etc/pki/rpm-gpg/RPM-GPG-KEY-neokylin-release" >> /etc/yum.repos.d/neokylin.repo
else
echo "gpgkey=file:///etc/pki/rpm-gpg/RPM-GPG-KEY-neokylin-\$basearch" >> /etc/yum.repos.d/neokylin.repo
fi
}

write_updates_repo()
{
echo "[neokylin-updates]
name=NeoKylin $3 Updates
baseurl=$1
enabled=$2
gpgcheck=1
skip_if_unavailable = 1" > /etc/yum.repos.d/neokylin-updates.repo
if [ $SYSTEM = "aarch64" ];then
echo "gpgkey=file:///etc/pki/rpm-gpg/RPM-GPG-KEY-neokylin-release" >> /etc/yum.repos.d/neokylin-updates.repo
elif [ $SYSTEM = "mips64el" ];then
echo "gpgkey=file:///etc/pki/rpm-gpg/RPM-GPG-KEY-neokylin-release" >> /etc/yum.repos.d/neokylin-updates.repo
else
echo "gpgkey=file:///etc/pki/rpm-gpg/RPM-GPG-KEY-neokylin-\$basearch" >> /etc/yum.repos.d/neokylin-updates.repo
fi

}

change_default_repo()
{
        sed -i "s/enabled[ ]*=[ ]*[0-9]/enabled=$1/g" /etc/yum.repos.d/neokylin.repo
        
        if [ $SYSTEM != "mips64el" ];then
            sed -i "s/enabled[ ]*=[ ]*[0-9]/enabled=$1/g" /etc/yum.repos.d/neokylin-updates.repo
        fi
}
change_repo()
{

        if [ $1 -eq 0 ];then
                yum-config-manager --disable $2 >> /dev/null 2>&1
        elif [ $1 -eq 1 ];then
                yum-config-manager --enable $2  >> /dev/null 2>&1
        else
                #yum-config-manager --enable $2
                echo "yum-config-manager error!"
        fi

#	 sed -i "s/enabled[ ]*=[ ]*[0-9]/enabled=$1/g" $2
#         sync
}


set_update_alarm()
{
        if [ $SYSTEM = "mips64el" ];then
                auto_update_script="\/usr\/sbin\/auto\_update\_notify\.sh\ $3"
                auto_update_script_org="/usr/sbin/auto_update_notify.sh $3"
        else
                auto_update_script="\/usr\/bin\/neokylin\-auto\-update"
                auto_update_script_org="/usr/bin/neokylin-auto-update"
        fi

	sed -i "/$3\ export\ DISPLAY\=\:0\ &&\ $auto_update_script/d" /etc/crontab

	if [ $2 -eq -1 ];then
		echo "0 $1 * * * $3 export DISPLAY=:0 && $auto_update_script_org" >> /etc/crontab
	else
		echo "0 $1 * * $2 $3 export DISPLAY=:0 && $auto_update_script_org" >> /etc/crontab
	fi

	systemctl restart crond
}

set_update_alarm_check()
{
        if [ $SYSTEM = "mips64el" ];then
                auto_update_script="\/usr\/sbin\/auto\_update\_notify\.sh\ $3"
                auto_update_script_org="/usr/sbin/auto_update_notify.sh $3"
        else
                auto_update_script="\/usr\/bin\/neokylin\-auto\-update"
                auto_update_script_org="/usr/bin/neokylin-auto-update"
        fi

	sed -i "/$3\ export\ DISPLAY\=\:0\ &&\ $auto_update_script/d" /etc/crontab

	if [ $2 -eq -1 ];then
		echo "0 $1 * * * $3 export DISPLAY=:0 && $auto_update_script_org --check" >> /etc/crontab
	else
		echo "0 $1 * * $2 $3 export DISPLAY=:0 && $auto_update_script_org --check" >> /etc/crontab
	fi

	systemctl restart crond
}

cancel_update_alarm()
{
        if [ $SYSTEM = "mips64el" ];then
                auto_update_script=\\/usr\\/sbin\\/auto\\_update\\_notify\\.sh
        else
                auto_update_script=\\/usr\\/bin\\/neokylin\\-auto\\-update
        fi

	sed -i "/$1\ export\ DISPLAY\=\:0\ &&\ $auto_update_script/d" /etc/crontab
}

SYSTEM=`uname -m`


s_version=
if [ $SYSTEM = "mips64" ];then
	online_url=http://download.cs2c.com.cn/neokylin/desktop/releases/7.2/ls_64/os
        default_url=http://download.cs2c.com.cn/neokylin/desktop/releases/7.2/ls_64/os
        updates_url=http://download.cs2c.com.cn/neokylin/desktop/updates/7.2/ls_64/os
elif [ $SYSTEM = "sw_64" ];then
	online_url=http://10.3.6.75/kojifiles/repos/nd7-sw_64-Release-build/latest/sw_64
elif [ $SYSTEM = "x86_64" ];then
	s_version=`cat /etc/.productinfo|sed -n '2,2p'|grep '5.0'`
	if [ "X"$s_version != "X" ];then
		online_url=http://download.cs2c.com.cn/neokylin/desktop/releases/5.1/x86_64/os/
	else
		online_url=http://download.cs2c.com.cn/neokylin/desktop/releases/7.1/x86_64/os/
	fi
        default_url=http://download.cs2c.com.cn/neokylin/desktop/releases/7.0/\$basearch/zx/os/
        updates_url=http://download.cs2c.com.cn/neokylin/desktop/updates/7.0/\$basearch/zx/os/
elif [ $SYSTEM = "i686" -o $SYSTEM = "i386" ];then
	s_version=`cat /etc/.productinfo|sed -n '2,2p'|grep '5.0'`
	if [ "X"$s_version != "X" ];then
		online_url=http://download.cs2c.com.cn/neokylin/desktop/releases/5.1/i386/os/
	else
		online_url=http://download.cs2c.com.cn/neokylin/desktop/releases/7.1/i386/os/
	fi
elif [ $SYSTEM = "aarch64" ];then
	online_url=http://download.cs2c.com.cn/neokylin/desktop/releases/7.0/\$basearch/os/
        default_url=http://download.cs2c.com.cn/neokylin/desktop/releases/7.0/aarch64/os/
        updates_url=http://download.cs2c.com.cn/neokylin/desktop/updates/7.0/aarch64/os/
elif [ $SYSTEM = "mips64el" ];then
	online_url=http://download.cs2c.com.cn/neokylin/server/releases/v10/ls_64/
	default_url=http://download.cs2c.com.cn/neokylin/server/releases/v10/ls_64/
	update_url=http://download.cs2c.com.cn/neokylin/server/updates/v10/ls_64/
else
	online_url=http://
fi

offline_url=file:///opt/update/

if [ $1 = "on" ];then
	if [ "X$3" = "X" ];then
		write_online_repo ${online_url} $2
	else
		write_online_repo $3 $2
	fi
elif [ $1 = "off" ];then
	if [ "X$3" = "X" ];then
		write_offline_repo ${offline_url} $2
		createrepo /opt/update
	else
		write_offline_repo $3 $2
	fi
elif [ $1 = "neokylin" ];then
        if [ $SYSTEM = "mips64" ];then
                write_default_repo ${default_url} $2 7.2
        else
                write_default_repo ${default_url} $2 7.0
        fi
elif [ $1 = "updates" ];then
        if [ $SYSTEM = "mips64" ];then
                write_updates_repo ${updates_url} $2 7.2
        else
                write_updates_repo ${updates_url} $2 7.0
        fi

elif [ $1 = "default" ];then
	change_default_repo $2
elif [ $1 = "alarm" ];then
	set_update_alarm $2 $3 $4
elif [ $1 = "cancel" ];then
	cancel_update_alarm $2
elif [ $1 = "update-all" ];then
	update_system
elif [ $1 = "alarm-check" ];then
	set_update_alarm_check $2 $3 $4
elif [ $1 = "clean" ];then
	clean
elif [ $1 = "repo-enabled" ];then
        change_repo $2 $3
else
	yum clean dbcache rpmdb
	echo "Please enter the params like on;off;default"
fi

exit 0

#yum clean all

